// MFCWebBrowserDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFCWebBrowserDemo.h"
#include "MFCWebBrowserDemoDlg.h"

#include "..\HTMLWriter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMFCWebBrowserDemoDlg dialog

CMFCWebBrowserDemoDlg::CMFCWebBrowserDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFCWebBrowserDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMFCWebBrowserDemoDlg)
	m_sHTML = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFCWebBrowserDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMFCWebBrowserDemoDlg)
	DDX_Control(pDX, IDC_EXPLORER, m_ctlWebBrowser);
	DDX_Text(pDX, IDC_HTML, m_sHTML);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMFCWebBrowserDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CMFCWebBrowserDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFCWebBrowserDemoDlg message handlers

BOOL CMFCWebBrowserDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_ctlWebBrowser.Navigate( _T("about:blank"), NULL, NULL, NULL, NULL );

	CHTMLWriter htmlWriter( m_ctlWebBrowser.GetControlUnknown() );

	htmlWriter.Write( _T("<html><head><title>My page</title></head>\n")
		_T("<body><p><font face=verdana size=2>This page is written dynamically to the\n")
		_T("WebBrowser control using the CHTMLWriter class.")
		_T("<br><br><a href=\"mailto:ehsan@beginthread.com\">Email me</a></font></p></body></html>") );
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFCWebBrowserDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFCWebBrowserDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMFCWebBrowserDemoDlg::OnAdd() 
{
	UpdateData( TRUE );

	CHTMLWriter htmlWriter( m_ctlWebBrowser.GetControlUnknown() );

	htmlWriter.Add( m_sHTML );
}